import javax.swing.UIManager;
import javax.swing.plaf.metal.MetalLookAndFeel;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.io.*;
import java.text.*;
import java.net.*;

public class SMTP {
    public SMTP() {
        SMTPFrame frame = new SMTPFrame();

        frame.validate();

        //Center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
    }
    /**Main method*/
    public static void main(String[] args) {
        try {
            UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        new SMTP();
    }
}

class SMTPFrame extends JFrame {
    JPanel contentPane;

    Border border1;
    Border border2;
    Border border3;
    Border border4;

    BorderLayout borderLayout1 = new BorderLayout();
    BorderLayout borderLayout2 = new BorderLayout();
    BorderLayout borderLayout3 = new BorderLayout();
    BorderLayout borderLayout4 = new BorderLayout();
    BorderLayout borderLayout5 = new BorderLayout();

    JPanel Panel1 = new JPanel();
    JPanel Panel2 = new JPanel();
    JPanel Panel3 = new JPanel();
    JPanel Panel4 = new JPanel();
    JPanel Panel5 = new JPanel();
    JPanel Panel6 = new JPanel();
    GridLayout gridLayout1 = new GridLayout();
    GridLayout gridLayout2 = new GridLayout();

    JMenuBar jMenuBar1 = new JMenuBar();
    JMenu jMenuFile = new JMenu();
    JMenuItem jMenuFileProfile = new JMenuItem();
    JMenuItem jMenuFileExit = new JMenuItem();

    JToolBar jToolBar = new JToolBar();
    JButton jButtonSend = new JButton();

    ImageIcon image1;
    ImageIcon image2;

    JTabbedPane jTabbedPane1 = new JTabbedPane();

    JScrollPane jScrollPane1 = new JScrollPane();
    JScrollPane jScrollPane2 = new JScrollPane();

    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JTextField jTo = new JTextField();
    JTextField jSubject = new JTextField();
    JTextArea jText = new JTextArea();
    JTextArea jLog = new JTextArea();

	// Constructor
    public SMTPFrame() {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);

        try {
			// Get current classloader
	   		ClassLoader cl = this.getClass().getClassLoader();
	   		// Create icons
	        image1 = new ImageIcon(cl.getResource("mail.gif"));
	        image2 = new ImageIcon(cl.getResource("send.gif"));
	        setIconImage(image1.getImage());
	        contentPane = (JPanel) this.getContentPane();
	        contentPane.setLayout(borderLayout1);
	        this.setSize(new Dimension(300, 350));
	        this.setTitle("SMTP");
	        this.setResizable(true);
	
	        jMenuFile.setMnemonic('F');
	        jMenuFile.setText("File");
	        jMenuFileProfile.setMnemonic('P');
	        jMenuFileProfile.setText("Profile");
	        jMenuFileProfile.addActionListener(new java.awt.event.ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	                jMenuFileProfile_actionPerformed(e);
	            }
	        });
	        jMenuFileExit.setMnemonic('X');
	        jMenuFileExit.setText("Exit");
	        jMenuFileExit.addActionListener(new ActionListener()  {
	            public void actionPerformed(ActionEvent e) {
	                jMenuFileExit_actionPerformed(e);
	            }
	        });
	
	        jMenuFile.add(jMenuFileProfile);
	        jMenuFile.addSeparator();
	        jMenuFile.add(jMenuFileExit);
	        jMenuBar1.add(jMenuFile);
	        this.setJMenuBar(jMenuBar1);
	
	        jButtonSend.setIcon(image2);
	        jButtonSend.setMaximumSize(new Dimension(35, 35));
	        jButtonSend.setMinimumSize(new Dimension(35, 35));
	        jButtonSend.setPreferredSize(new Dimension(35, 35));
	        jButtonSend.setToolTipText("Send Mail");
	        jButtonSend.setVerticalTextPosition(SwingConstants.BOTTOM);
	        jButtonSend.setHorizontalTextPosition(SwingConstants.CENTER);
	        jButtonSend.addActionListener(new java.awt.event.ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	                jButtonSend_actionPerformed(e);
	            }
	        });
	
	        Panel1.setLayout(borderLayout2);
	
	        Panel2.setMinimumSize(new Dimension(10, 70));
	        Panel2.setPreferredSize(new Dimension(10, 70));
	        Panel2.setToolTipText("");
	        Panel2.setLayout(borderLayout3);
	
	        border3 = BorderFactory.createCompoundBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142)),BorderFactory.createEmptyBorder(4,5,4,4));
	        Panel3.setBorder(border3);
	        Panel3.setLayout(borderLayout4);
	
	   		border1 = BorderFactory.createEmptyBorder(4,10,4,2);
	        Panel4.setBorder(border1);
	        gridLayout1.setRows(2);
	        gridLayout1.setColumns(1);
	        gridLayout1.setHgap(2);
	        gridLayout1.setVgap(4);
	        Panel4.setLayout(gridLayout1);
	        Panel4.setMaximumSize(new Dimension(70, 10));
	        Panel4.setMinimumSize(new Dimension(70, 10));
	        Panel4.setPreferredSize(new Dimension(70, 10));
	        Panel4.setToolTipText("");
	
	        border2 = BorderFactory.createEmptyBorder(4,2,4,2);
	        Panel5.setBorder(border2);
	        gridLayout2.setRows(2);
	        gridLayout2.setColumns(1);
	        gridLayout2.setHgap(2);
	        gridLayout2.setVgap(4);
	        Panel5.setLayout(gridLayout2);
	
	        border4 = BorderFactory.createEmptyBorder(2,4,2,2);
	        Panel6.setLayout(borderLayout5);
	        Panel6.setBorder(border4);
	
	        jToolBar.add(jButtonSend);
	        contentPane.add(jToolBar, BorderLayout.NORTH);
	
	        jLabel1.setText("To:");
	        jLabel2.setText("Subject:");
	        Panel4.add(jLabel1, null);
	        Panel4.add(jLabel2, null);
	        Panel2.add(Panel4, BorderLayout.WEST);
	        Panel5.add(jTo, null);
	        Panel5.add(jSubject, null);
	        Panel2.add(Panel5, BorderLayout.CENTER);
	        Panel3.add(jScrollPane1, BorderLayout.CENTER);
	        jScrollPane1.getViewport().add(jText, null);
	        Panel1.add(Panel3, BorderLayout.CENTER);
			Panel1.add(Panel2, BorderLayout.NORTH);
	        jTabbedPane1.add(Panel1, "SMTP");
	
	        Panel6.add(jScrollPane2, BorderLayout.CENTER);
	        jScrollPane2.getViewport().add(jLog, null);
	        jTabbedPane1.add(Panel6, "Transaction");
	        contentPane.add(jTabbedPane1, BorderLayout.CENTER);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    public void jMenuFileExit_actionPerformed(ActionEvent e) {
        System.exit(0);
    }

    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            jMenuFileExit_actionPerformed(null);
        }
    }

    public void jMenuFileProfile_actionPerformed(ActionEvent e) {
        ProfileDialog dlg = new ProfileDialog(this);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        dlg.setModal(true);
        dlg.show();
    }

    void jButtonSend_actionPerformed(ActionEvent e) {
		try {
			// Thread to Send Mail
			Thread thread = new Thread((new sendMail(this)));
			thread.start();
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}
    }
}

class sendMail extends Thread implements Runnable {
  private BufferedReader J;
  private BufferedWriter X;
	private Socket cs;

    private String host, port, user, name, addr;
    private String to, subject, msgText;
	private int length;

	private SMTPFrame frame;
	private String linesep;

	// Constructor
	public sendMail(SMTPFrame frame) {
		this.frame = frame;

		// user entry
		to = frame.jTo.getText();
    	subject = frame.jSubject.getText();
    	msgText = frame.jText.getText();
	}

    void loadProperties() {
        // Line Separator
        linesep = System.getProperty("line.separator");

		try {
			Properties p = new Properties();
			FileInputStream in = new FileInputStream("smtp.properties");

			p.load(in);

            host = p.getProperty("smtp.host");
            port = p.getProperty("smtp.port");
            user = p.getProperty("smtp.username");
            name = p.getProperty("smtp.name");
            addr = p.getProperty("smtp.address");

            in.close() ;
		}
		catch (Exception ex) {
			System.out.println(ex.getMessage());
		}
	}

	// Send message to SMTP server
	void SMTPSend(String msg, boolean msgEnd, boolean msgFlush) throws IOException {		
		length = msg.length();

		for (int i = 0; i < msg.length(); i++)
			X.write(msg.charAt(i));

		if (msgEnd) {
			X.write('\r');
			X.write('\n');
		}
		if (msgFlush) {
			X.flush();
		}

        frame.jLog.append("C: " + msg + linesep);
	}

	// Get response from SMTP server
	void SMTPResponse(String cmd, String okMsg) throws IOException {
		String response;

		response = J.readLine();
		
		if (!response.startsWith(cmd)) {
			frame.jLog.append("S: " + cmd + " " + response + linesep);
		}
		while (response.startsWith(cmd + '-'))
			response = J.readLine();

		frame.jLog.append("S: " + okMsg	+ linesep);		
	}

	// Get response from SMTP server
	void SMTPResponse(String cmd, String okMsg, String errMsg) throws IOException {
		String response;
		
		response = J.readLine();
		
		if (!response.startsWith(cmd)) {
			frame.jLog.append("S: " + cmd + " " + response + linesep);
		}
		while (response.startsWith(cmd + '-'))
			response = J.readLine();
			
		frame.jLog.append("S: " + okMsg + linesep);		
	}

	public void run() {
		String request;
		String msg;
		
	    if (to.equals("")) {
	        String dMessage = "Please enter the e-mail address.";
	        String dTitle   = "SMTP Error";
	        int dType = JOptionPane.ERROR_MESSAGE ;
	
	        JOptionPane.showMessageDialog((Component) null, dMessage, dTitle, dType);
	    }
	    else {
	    	// Load the default properties
	        loadProperties();
	        
	        // Clear the transaction JTextArea
	        frame.jLog.setText("");
	
			try {
				// Connect to SMTP server
				frame.jLog.append("C: Trying to connect to host " + host + ", port: " + port + linesep);
				
				cs = new Socket(InetAddress.getByName(host), Integer.parseInt(port));
	
				frame.jLog.append("C: Connected to " + host + ", port: " + port + linesep);

	            try {
	            	// Create the I/O Stream of Socket
					J  = new BufferedReader(new InputStreamReader(cs.getInputStream()));
	                X = new BufferedWriter(new OutputStreamWriter(cs.getOutputStream()));
	
					msg = "220 " + host + " Simple Mail Transfer Service Ready" ;
					SMTPResponse("220", msg);
					
					// Talk to server (HELO)
	                msg = "HELO " + host;
					SMTPSend(msg, true, true) ;
	
					// Check response from server (HELO)
					msg = "250 " + host ;
					SMTPResponse("250", msg);

					// Check MAIL FROM Address is valid or not
	                msg = "MAIL FROM:<" + addr.trim() + ">";
					SMTPSend(msg, true, true);

					// Check response from server (MAIL FROM)
					SMTPResponse("250", "250 OK", "No such user here");
	
					// Check RCPT TO Address(es) are valid or not
					StringTokenizer tokenizer = new StringTokenizer(to, ",");
					
					while (tokenizer.hasMoreTokens()) {
						String rcptTo = tokenizer.nextToken().trim();
	
		                msg = "RCPT TO:<" + rcptTo + ">";
						SMTPSend(msg, true, true);

						// Check response from server (RCPT TO)
						msg = "250 OK" ;
						SMTPResponse("250", "250 OK", "No such user here");
					}
	
					// Start to send the message content
	                msg = "DATA";
					SMTPSend(msg, true, true);

					msg = "354 Start mail input; end with <CRLF>.<CRLF>" ;
					SMTPResponse("354", msg);
	
					// Start DATE
		            Date sentDate = new Date();
		            SimpleDateFormat formatter1 = new SimpleDateFormat("EEE, d MMM yyyy hh:mm:ss z");
					msg = "Date: " + formatter1.format(sentDate) ;
					SMTPSend(msg, true, false);

					// Start FROM
					msg = "From: " + addr.trim() ;
					SMTPSend(msg, true, false);
	
					// Start TO
					msg = "To: " + to ;
					SMTPSend(msg, true, false);
	
					// Start SUBJECT
					msg = "Subject: " + subject ;
					SMTPSend(msg, true, false);

					X.write('\r');
					X.write('\n');
			
					// Start Content
			        StringBuffer content = new StringBuffer(msgText.length());
			        int k = 0, l;
			
			        while ((l = msgText.indexOf("\n.", k)) != -1) {
			            content.append(msgText.substring(k, l) + "\n..");
			            k = l + 2;
			        }
			        if (k > 0) {
			            content.append(msgText.substring(k));
	
						msg = content.toString() ;
			        } else {
						msg = msgText ;
			        }

					SMTPSend(msg, true, false);
	
					msg = String.valueOf(".") ;
					SMTPSend(msg, true, true);

					msg = "250 OK" ;
					SMTPResponse("250", msg);

					// End of Connection
					msg = "QUIT";
					SMTPSend(msg, true, true);
	                
					msg = "221 " + host + " Service closing transimmsion channel" ;
					SMTPResponse("221", msg);

					// Close I/O Stream and Socket
	                X.close();
	                J.close();
	                cs.close();
	            } 
	            catch (Exception ex) {
		            ex.printStackTrace();
		            try {
	    	            cs.close();
		            } 
		            catch (IOException ioex) {
			            ioex.printStackTrace();
			        }    	            
	            }
	        } 
		    catch (UnknownHostException e) {
				e.printStackTrace();
		    }
		    catch (IOException ex) {
				ex.printStackTrace();
			} 
	    }
	}	 
}

class ProfileDialog extends JDialog implements ActionListener {
    Border border1;
    Border border2;
    Border border3;
    Border border4;
    Border border5;

    BorderLayout borderLayout1 = new BorderLayout();
    BorderLayout borderLayout2 = new BorderLayout();
    BorderLayout borderLayout3 = new BorderLayout();

    GridLayout gridLayout1 = new GridLayout();
    GridLayout gridLayout2 = new GridLayout();
    GridLayout gridLayout3 = new GridLayout();
    GridLayout gridLayout4 = new GridLayout();

    TitledBorder titledBorder1;
    TitledBorder titledBorder2;

    JPanel panel1 = new JPanel();
    JPanel Panel2 = new JPanel();
    JPanel Panel3 = new JPanel();
    JPanel Panel4 = new JPanel();
    JPanel Panel5 = new JPanel();
    JPanel Panel6 = new JPanel();
    JPanel Panel7 = new JPanel();
    JPanel Panel8 = new JPanel();

    JLabel jLabel1 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JLabel jLabel4 = new JLabel();
    JLabel jLabel5 = new JLabel();

    JTextField jHost = new JTextField();
    JTextField jUser = new JTextField();
    JTextField jPort = new JTextField();
    JTextField jName = new JTextField();
    JTextField jAddr = new JTextField();

    JButton jButtonOK = new JButton();
    JButton jButtonCancel = new JButton();

    public ProfileDialog(SMTPFrame parent) {
        super(parent);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);

        try {
	        this.setTitle("SMTP Profile");
	
	        this.setResizable(false);
	
	        panel1.setLayout(borderLayout1);
	        panel1.setBorder(BorderFactory.createEtchedBorder());
	        panel1.setMinimumSize(new Dimension(290, 270));
	        panel1.setPreferredSize(new Dimension(290, 270));
	
	
	        titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"Outgoing Mail (SMTP)");
	        Panel2.setBorder(titledBorder1);
	        Panel2.setMinimumSize(new Dimension(10, 120));
	        Panel2.setPreferredSize(new Dimension(10, 120));
	        Panel2.setLayout(borderLayout2);
	
	        titledBorder2 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"User Information");
	        Panel3.setBorder(titledBorder2);
	        Panel3.setMinimumSize(new Dimension(10, 120));
	        Panel3.setPreferredSize(new Dimension(10, 120));
	        Panel3.setLayout(borderLayout3);
	
	        border1 = BorderFactory.createEmptyBorder(4,10,4,2);
	        border5 = BorderFactory.createEmptyBorder(4,0,4,0);
	        Panel4.setBorder(border5);
	        Panel4.setMinimumSize(new Dimension(10, 50));
	        Panel4.setPreferredSize(new Dimension(10, 50));
	        Panel5.setBorder(border1);
	
	        gridLayout1.setRows(3);
	        gridLayout1.setColumns(1);
	        gridLayout1.setHgap(2);
	        gridLayout1.setVgap(2);
	        Panel5.setMinimumSize(new Dimension(80, 10));
	        Panel5.setPreferredSize(new Dimension(80, 10));
	        Panel5.setLayout(gridLayout1);
	
	        border2 = BorderFactory.createEmptyBorder(4,2,4,5);
	        gridLayout2.setRows(3);
	        gridLayout2.setColumns(1);
	        gridLayout2.setHgap(2);
	        gridLayout2.setVgap(4);
	        Panel6.setLayout(gridLayout2);
	        Panel6.setBorder(border2);
	
	        border3 = BorderFactory.createEmptyBorder(4,10,4,2);
	        gridLayout3.setRows(2);
	        gridLayout3.setColumns(1);
	        gridLayout3.setHgap(2);
	        gridLayout3.setVgap(4);
	        Panel7.setMinimumSize(new Dimension(80, 10));
	        Panel7.setPreferredSize(new Dimension(80, 10));
	        Panel7.setLayout(gridLayout3);
	        Panel7.setBorder(border3);
	
	        border4 = BorderFactory.createEmptyBorder(4,2,4,5);
	        gridLayout4.setRows(2);
	        gridLayout4.setColumns(1);
	        gridLayout4.setHgap(2);
	        gridLayout4.setVgap(4);
	        Panel8.setBorder(border4);
	        Panel8.setLayout(gridLayout4);
	
	        jLabel1.setText("SMTP Host:");
	        jLabel2.setText("SMTP Port:");
	        jLabel3.setText("User name:");
	        jLabel4.setText("Name:");
	        jLabel5.setText("Address:");
	
	        jButtonOK.setMaximumSize(new Dimension(80, 30));
	        jButtonOK.setMinimumSize(new Dimension(80, 30));
	        jButtonOK.setPreferredSize(new Dimension(80, 30));
	        jButtonOK.setMnemonic('O');
	        jButtonOK.setText("OK");
	        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	                jButtonOK_actionPerformed(e);
	            }
	        });
	
	        jButtonCancel.setMaximumSize(new Dimension(80, 30));
	        jButtonCancel.setMinimumSize(new Dimension(80, 30));
	        jButtonCancel.setPreferredSize(new Dimension(80, 30));
	        jButtonCancel.setMnemonic('C');
	        jButtonCancel.setText("Cancel");
	        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	                jButtonCancel_actionPerformed(e);
	            }
	        });
	
	        this.getContentPane().add(panel1, BorderLayout.WEST);
	
	        Panel5.add(jLabel1, null);
	        Panel5.add(jLabel2, null);
	        Panel5.add(jLabel3, null);
	        Panel2.add(Panel5, BorderLayout.WEST);
	
	        Panel6.add(jHost, null);
	        Panel6.add(jPort, null);
	        Panel6.add(jUser, null);
	        Panel2.add(Panel6, BorderLayout.CENTER);
	
	        panel1.add(Panel2, BorderLayout.NORTH);
	
	        Panel7.add(jLabel4, null);
	        Panel7.add(jLabel5, null);
	        Panel3.add(Panel7, BorderLayout.WEST);
	
	        Panel8.add(jName, null);
	        Panel8.add(jAddr, null);
	        Panel3.add(Panel8, BorderLayout.CENTER);
	
	        panel1.add(Panel3, BorderLayout.CENTER);
	
	        Panel4.add(jButtonOK, null);
	        Panel4.add(jButtonCancel, null);
	
	        panel1.add(Panel4, BorderLayout.SOUTH);
	
			// Pack the Dialog
            pack();

			// Load the default properties
	        loadProperties();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }

    void loadProperties() {
		try {
			Properties p = new Properties();

			FileInputStream in = new FileInputStream("smtp.properties");

			p.load(in);

            jHost.setText(p.getProperty("smtp.host")) ;
            jPort.setText(p.getProperty("smtp.port"));
            jUser.setText(p.getProperty("smtp.username"));
            jName.setText(p.getProperty("smtp.name"));
            jAddr.setText(p.getProperty("smtp.address"));

            in.close() ;
		}
		catch (Exception ex) {
			System.out.println(ex.getMessage());
		}
	}

    void saveProperties() {
		try {
			Properties p = new Properties();

			FileOutputStream os = new FileOutputStream("smtp.properties");

            p.setProperty("smtp.host", jHost.getText()) ;
            p.setProperty("smtp.port", jPort.getText()) ;
            p.setProperty("smtp.username", jUser.getText()) ;
            p.setProperty("smtp.name", jName.getText()) ;
            p.setProperty("smtp.address", jAddr.getText()) ;

			p.store(os, null);
			os.close();
        }
		catch (Exception ex) {
			System.out.println(ex.getMessage());
		}
	}

    protected void processWindowEvent(WindowEvent e) {
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            cancel();
        }
        super.processWindowEvent(e);
    }

    void cancel() {
        dispose();
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == jButtonOK) {
            saveProperties();
        }
        else if (e.getSource() == jButtonCancel) {
            cancel();
        }
    }

    void jButtonOK_actionPerformed(ActionEvent e) {
        saveProperties();
        cancel();
    }

    void jButtonCancel_actionPerformed(ActionEvent e) {
        cancel();
    }
}

